<?php

include_once('captcha/class.captcha.php');

$CaptchaTempDir = 'wiki.d/captcha.temp';


$OrigHandleActions = Array();

function CaptchaAction($action) {
    global $OrigHandleActions, $HandleActions;
    $OrigHandleActions[$action] = $HandleActions[$action];
    $HandleActions[$action] = 'HandleDisplayCaptcha';
}


function SaveArray(&$array,$var) {
   unset($_SESSION[$var]);
   $newArr = Array();
   foreach ($array as $key => $value) {
      $newArr[$key] = $value;
   }
   $_SESSION[$var] = $newArr;
}

function RestoreArray(&$array, $var) {
   foreach ($array as $key => $value) {  
      unset($array[$key]);
   }
   foreach ($_SESSION[$var] as $key => $value) {
      $array[$key] = $value;
   }
}



$HandleActions['captcha'] = 'HandleDisplayCaptcha';
function HandleDisplayCaptcha($pagename,$savesession=true) {
   global $PubDirUrl,$CaptchaTempDir,$action;
   mkdirp($CaptchaTempDir);
 session_start();
   if ($savesession) {
      SaveArray($_POST,'captcha_post');
      SaveArray($_GET,'captcha_get');
      SaveArray($_REQUEST,'captcha_request');
      $_SESSION['captcha_action'] = $action;
   }

   if (!isset($_SESSION['captcha_session'])) {
 	  $_SESSION['captcha_session'] = md5(round(rand(0,40000)));
   }
   $session_code = $_SESSION['captcha_session'];

   $my_captcha = new captcha( $session_code, $CaptchaTempDir);
   $pic_url = $my_captcha->get_pic(6);
   
   print FmtPageName("<html><body><form name='captchaform' method='post' action='{\$PageUrl}'>
         <img src='$PubDirUrl/captcha/captcha_image.php?img=$pic_url&name=$pic_url.jpg' border='1' />
         <p>Enter displayed code?</p> <input type='text' name='password' /></p>
         <input type='hidden' name='action' value='verifycaptcha' />
         <p><input type='submit' name='submit' value='Enter' /></p>
         <p><a href='{\$PageUrl}'>Cancel</a></p>
      </form></body></html>" ,$pagename);
}


$HandleActions['verifycaptcha'] = 'HandleVerifyCaptcha';
function HandleVerifyCaptcha($pagename) {
    global $CaptchaTempDir,$OrigHandleActions,$action;
    session_start();
    $my_captcha = new captcha($_SESSION['captcha_session'],$CaptchaTempDir);
    if ($my_captcha->verify($_POST['password'])) {
         // Restore POST,GET,REQUEST and $action.
	 
         RestoreArray($_POST,'captcha_post');
         RestoreArray($_GET,'captcha_get');
         RestoreArray($_REQUEST,'captcha_request');
         $action = $_SESSION['captcha_action'];
	 unset($_SESSION['captcha_session']);

//   Header('Content-type: text/plain');
//	 print_r($GLOBALS);
// 	 exit;
         return $OrigHandleActions[$action]($pagename);
    }
    echo "Password incorrect";
    return HandleDisplayCaptcha($pagename,false);
}


?>
